#include <iostream>
#include <vector>
#include <time.h>

#include "bdd.h"
#include "./formulas/formula.h"
#include "./formulas/GML_formula.h"
#include "./formulas/PML_formula.h"
#include "./formulas/rational.h"
#include "./formulas/satisfyingassignment.h"
#include "satisfyingstack.h"
#include "./parser/mlf-driver.h"
#include "onestep.h"

using namespace std;

int main (int argc, char *argv[]){
	clock_t total_time = clock();
	IFormula* f = NULL;
    // this turns into an endless loop
	//bdd b = bdd_and(f->modal(new bdd(f->variable(0)), 4, 0),
	//                bdd_not(f->modal(new bdd(f->variable(0)), 6, 0)));
	if (true) {
		mlf_driver driver;
		driver.set_formula_gml();
		if (!driver.parse ("-")) {
			driver.extract_formula(f);
		}
	} else {
		f = new GML_Formula;
		bdd b = bdd_and(bdd_and(f->modal(new bdd(f->variable(8)), 4, 0),
					   bdd_not(f->modal(new bdd(bdd_not(f->variable(7))), 3, 0))),
					   bdd_not(f->modal(new bdd(bdd_not(f->variable(9))), 3, 0)));
		f->set_bdd(b);
	}
	// bdd_varblockall();
	// bdd_reorder(BDD_REORDER_WIN3ITE);
	// bdd_printdot((driver.formula)->bdd_rep);
	//bdd_printset(f->get_bdd());
	//cout << endl;
	//(driver.formula)->print_back_vars();
	//vector<RuleChild> res = f->onestep_rules(b);
	//cout << res.size() << " childs" << endl;
	//for (unsigned int r = 0; r < res.size(); r++) {
	//	RuleChild& rc = res[r];
	//	for (unsigned int i = 0; i < rc.size(); i++) {
	//		cout << "\\/ (";
	//		for (unsigned int j = 0; j < rc[i].size(); j++) {
	//			pair<bool,int>& p = rc[i][j];
	//			if (j != 0) cout << ", ";
	//			if (!p.first) cout << "~";
	//			cout << p.second;
	//		}
	//		cout << ")";
	//	}
	//	cout << endl;
	//}
	if (f) {
		RuleCollection vsa = f->onestep();
		printRuleCollection(vsa);
		f->clear_maps();
		delete f;
	}
	total_time = clock() - total_time;
	cout << "Total Time: " << static_cast<float>(total_time) / CLOCKS_PER_SEC << endl;
	return 0;
}

